if(!isObject(ColorSetGui_Favs)) {
	exec("./ColorSetGui_Favs.gui");
	ColorSetGui.getObject(0).add(ColorSetGui_Favs);
}

package AvatarColorFavs {
	function ColorSetGui::onWake(%this) {
		Parent::onWake(%this);
		ColorSetGui.updateFavButtons ();
		AVC_FavsHelper.setVisible (0);
	}
	function ColorSetGui::updateFavButtons ()
	{
		for (%i = 0; %i < 10; %i++)
		{
			%filename = "config/client/AvatarColorFavorites/" @ %i @ ".cs";
			if (isFile (%filename))
			{
				eval ("AvatarColor_FavButton" @ %i @ ".setColor(\"1 1 1 1\");");
			}
			else 
			{
				eval ("AvatarColor_FavButton" @ %i @ ".setColor(\"1 1 1 0.5\");");
			}
		}
	} 

	function ColorSetGui::clickSetFavs (%this)
	{
		AVC_FavsHelper.setVisible (!AVC_FavsHelper.isVisible ());
	}

	function ColorSetGui::ClickFav (%this, %idx)
	{
		%idx = mFloor (%idx);
		%filename = "config/client/AvatarColorFavorites/" @ %idx @ ".cs";
		if (AVC_FavsHelper.isVisible ())
		{
			export ("$Avatar::*", %filename, 0);
			AVC_FavsHelper.setVisible (0);
		}
		else 
		{
			if (!isFile (%filename))
			{
				return;
			}
			deleteVariables ("$Avatar::*");
			exec (%filename);
			%this.Display ();
		}
		%this.updateFavButtons ();
	}
	
	function ColorSetGui::loadColorSet(%this,%filename)
	{
		if(%filename $= "")
			%filename = "config/server/colorSet.txt";
		
		if(!isFile(%filename))
			return 0;
		
		deleteVariables ("$Avatar::*");
		%file = new FileObject ("");
		%file.openForRead (%filename);
		%i = -1;
		//%divCount = -1;
		while (!%file.isEOF ())
		{
			%line = %file.readLine ();
			if (getSubStr (%line, 0, 4) $= "DIV:")
			{
				//%divName = getSubStr (%line, 4, strlen (%line) - 4);
				//setSprayCanDivision (%divCount += 1, %i, %divName);
			}
			else if (%line !$= "")
			{
				if (%i >= 63)
				{
					break;
				}
				%r = mAbs (getWord (%line, 0));
				%g = mAbs (getWord (%line, 1));
				%b = mAbs (getWord (%line, 2));
				%a = mAbs (getWord (%line, 3));
				if (mFloor (%r) != %r || mFloor (%g) != %g || mFloor (%b) != %b || mFloor (%a) != %a || (%r <= 1 && %g <= 1 && %b <= 1 && %a <= 1))
				{
					
					if(%a < 0.2) // server doesn't accept transparent accent colors below 0.2
						%a = 0.2;
					$Avatar::Color[%i += 1] = %r SPC %g SPC %b SPC %a;
				}
				else 
				{
					if(%a < 51) // 255 * 0.2
						%a = 51;
					$Avatar::Color[%i += 1] = IColorToFColor (%r SPC %g SPC %b SPC %a);
				}
			}
		}
		%file.close ();
		%file.delete ();
		$Avatar::NumColors = %i += 1;
		%this.Display ();
		return 1;
	}
};
activatePackage("AvatarColorFavs");

exec("./colorManagerHook.cs");
