// load a stripped down copy of the RTB v4.02 color manager if we don't already have one
if(!isObject(RTB_ColorManager) && !isObject(ColorManagerGui))
	exec("./RTB_ColorManager/colorManager.cs"); 

if(!isObject(ColorSetGui_ColorManager)) {
	new GuiBitmapButtonCtrl(ColorSetGui_ColorManager)
	{
		Profile = "BlockButtonProfile";
		HorizSizing = "right";
		VertSizing = "top";
		position = "226 236";
		Extent = "91 18";
		MinExtent = "8 2";
		Visible = "1";
		Command = isObject(ColorManagerGui) ? "canvas.pushDialog(ColorManagerGui);" : "canvas.pushDialog(RTB_ColorManager);";
		buttonType = "PushButton";
		text = "Import >>";
		textID = "UI_BTN_IMPORT_COLORSET";
		locale = ExpandFilename ("./lang/");
		bitmap = "base/client/ui/button1";
		mColor = "255 255 255 255";
	};
	ColorSetGui.getObject(0).add(ColorSetGui_ColorManager);
}

package AvatarColorFavs_LoadColorset {
	// RTB color manager
	function RTB_ColorManager::saveSet(%this) {
		if(ColorSetGui.isAwake()) {
			if($RTB::MCCM::Selected !$= "") { // RTB3
				ColorSetGui.loadColorSet($RTB::MCCM::Selected);
				canvas.popDialog(%this);
			}
			else if($RTB::CColorManager::SelectedSet !$= "") { // RTB2
				ColorSetGui.loadColorSet($RTB::CColorManager::SelectedSet);
				canvas.popDialog(RTB_ColorManager);
			} else {
				error("ERROR: Unable to find selected colorset.");
				canvas.popDialog(%this);
			}
		}
		else
			return Parent::saveSet(%this);
	}
	
	// Blockland Rebuilt v2.12's built in color manager
	function ColorManagerGui::saveSet(%this) {
		if(ColorSetGui.isAwake()) {
			ColorSetGui.loadColorSet($ColorManager::Selected);
			canvas.popDialog(%this);
		}
		else
			return Parent::saveSet(%this);
	}
};
activatePackage("AvatarColorFavs_LoadColorset");